spool BD\29-logTR_AFT_INS_DESC_EST1_2.log

connect TFC/hola;


CREATE OR REPLACE TRIGGER TFC.TR_AFT_INS_DESC_EST1_2_TC1
AFTER INSERT ON TFC.DESCARREGAS  
DECLARE 
factacum NUMBER;
/*******************************************************************************
*Este trigger acumula para despues de cada descarga 
*el total facturado y nmero de descargas y va actualizando 
* la nica fila de la tabla
*******************************************************************************/

BEGIN
 UPDATE  tfc.totales
 SET totales.numdescarregas = totales.numdescarregas + 1;
 
 
 SELECT * INTO factacum FROM
 (SELECT PREUAPLICACIO FROM 
 descarregas
 ORDER BY iddescarrega DESC)
 WHERE ROWNUM = 1;
 
 
UPDATE  tfc.totales
 SET totales.factdescarregas = totales.factdescarregas + factacum;
 

END TR_AFT_INS_DESC_EST1_2_TC1;              

/
spool off;
