spool BD\30-logTR_AFT_INS_DESC_EST3_TC1.log
Connect TFC/hola;


CREATE OR REPLACE TRIGGER TFC.TR_AFT_INS_DESC_EST3_TC1
AFTER INSERT ON TFC.DESCARREGAS  
DECLARE
usuariodif NUMBER;
numdesc NUMBER;
mediaper NUMBER;
aomedia NUMBER;
anyultimo NUMBER;
ult_iddescarrega NUMBER;
existeMed  VARCHAR2(3);
existeUsr VARCHAR2(3);
existeAny VARCHAR2(3);
numusdifperany NUMBER;
totaldescperany NUMBER;
usrultimo NUMBER;

/*******************************************************************************
*Este trigger acumula para despus de cada descarga por ao 
* el numero de descargas de ese ao y el numero de usuarios diferentes para ese 
* ao. En otra tabla acumula la media de descargas para un ao de los usuarios
* que han descargado
********************************************************************************/

BEGIN


SELECT * 
INTO ult_iddescarrega 
FROM 
(SELECT  (DESCARREGAS.IDDESCARREGA)
FROM tfc.DESCARREGAS
ORDER BY iddescarrega DESC)
WHERE ROWNUM  = 1;

SELECT  (DESCARREGAS.AO)
INTO anyultimo 
FROM DESCARREGAS
where iddescarrega =ult_iddescarrega;

SELECT usr.idusuari
INTO usrultimo
FROM(( descarregas dc INNER JOIN imei im ON im.codimei = dc.codimei)
INNER JOIN usuaris usr ON im.idusuariimei =usr.idusuari)
where dc.iddescarrega=ult_iddescarrega;

BEGIN

SELECT * 
INTO numusdifperany
FROM 
(SELECT  (numusuariany.numusdifany)
FROM tfc.numusuariany
WHERE
numusuariany.anyusuari =anyultimo
ORDER BY numusuariany.numusdifany DESC)
WHERE ROWNUM  = 1;
EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        NULL;
        END;

IF numusdifperany IS NULL
THEN
numusdifperany := 0;
END IF;


BEGIN
SELECT * 
INTO totaldescperany
FROM 
(SELECT  (numusuariany.sumdesc)
FROM tfc.numusuariany
WHERE
numusuariany.anyusuari =anyultimo
ORDER BY numusuariany.sumdesc DESC)
WHERE ROWNUM  = 1;

EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN NULL;
        END;
        
IF (totaldescperany IS NULL)
THEN
totaldescperany := 0;
END IF;


BEGIN
SELECT 'S'
         INTO existeAny
         FROM tfc.numusuariany
         WHERE numusuariany.anyusuari  = anyultimo
         AND ROWNUM  = 1;
        
 EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
        INSERT INTO TFC.numusuariany (anyusuari,idusuariany,numusdifany,sumdesc)
        VALUES(anyultimo,usrultimo, (numusdifperany + 1),(totaldescperany +1));
        END;
    
END;
BEGIN
IF existeAny = 'S'
         THEN
         BEGIN
                     
         SELECT 'S'
         INTO existeUsr
         FROM tfc.numusuariany
        WHERE numusuariany.idusuariany = usrultimo
        AND numusuariany.anyusuari  = anyultimo
         AND ROWNUM  = 1;
         EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
        INSERT INTO TFC.numusuariany (anyusuari,idusuariany,numusdifany,sumdesc)
        VALUES(anyultimo,usrultimo, (numusdifperany + 1),(totaldescperany +1));
        END;
        END;
      END IF;
 END;     
BEGIN
IF existeUsr = 'S'
         THEN
         BEGIN
INSERT INTO TFC.numusuariany (anyusuari,idusuariany,numusdifany,sumdesc)
        VALUES(anyultimo,usrultimo, (numusdifperany ),(totaldescperany +1));
        END;
 END IF;
 END;

BEGIN
SELECT 'S'
         INTO existeMed
         FROM tfc.mediadescperusuari
        WHERE anymediadesc  = anyultimo
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
        INSERT INTO tfc.mediadescperusuari (anymediadesc,mediadesc,numdescargas,numusdif)
  VALUES(anyultimo,1,1,1);
  
  END;
  
END;  

BEGIN
  
  SELECT * 
INTO numusdifperany 
FROM 
(SELECT  (numusuariany.numusdifany)
FROM tfc.numusuariany
WHERE numusuariany.anyusuari = anyultimo
ORDER BY numusuariany.sumdesc DESC)
WHERE ROWNUM  = 1;
  
  SELECT * 
INTO totaldescperany 
FROM 
(SELECT  (numusuariany.sumdesc)
FROM tfc.numusuariany
WHERE numusuariany.anyusuari = anyultimo
ORDER BY numusuariany.sumdesc DESC)
WHERE ROWNUM  = 1;

  IF existeMed = 'S'
  THEN
  UPDATE TFC.mediadescperusuari
SET mediadescperusuari.mediadesc = totaldescperany/numusdifperany,
    mediadescperusuari.numusdif = numusdifperany,
    mediadescperusuari.numdescargas = totaldescperany
  WHERE
  mediadescperusuari.anymediadesc =anyultimo;
END IF;
END;


END TR_AFT_INS_DESC_EST3_TC1;
/
spool off;
