spool BD\32-logTR_AFT_INS_DESC_EST5.log
CONNECT TFC/hola;

create or replace TRIGGER TFC.TR_AFT_INS_DESC_EST5_TC1
AFTER INSERT ON TFC.DESCARREGAS  
DECLARE
precioapp NUMBER;
numdesenv NUMBER;
nomempresa VARCHAR2(50);
nomapp  VARCHAR2(40);
factacumulada NUMBER(5,2);
numdesc NUMBER;
mediaper NUMBER;
aomedia NUMBER;
aoultimo NUMBER;
idap    NUMBER; 
ult_iddescarrega NUMBER;
EXISTE  VARCHAR2(3);
existeAPA VARCHAR2(1);
existeMPA VARCHAR2(1);
totalnuevo NUMBER;

/*******************************************************************************
*Este trigger calcula para despues de cada ao
*la aplicacin que ms dinero ha recaudado y su desarrollador
*mediante IF ELSE comprueba que que se tengamos el ao para actualizarlo
*o insertarlo en la tabla mediadescperusuari
********************************************************************************/


BEGIN

SELECT * 
INTO ult_iddescarrega 
FROM 
(SELECT  (DESCARREGAS.IDDESCARREGA)
FROM tfc.DESCARREGAS
ORDER BY iddescarrega DESC)
WHERE ROWNUM  = 1;


SELECT  (DESCARREGAS.AO)
INTO aoultimo 
FROM DESCARREGAS
where iddescarrega =ult_iddescarrega;

SELECT * INTO nomempresa FROM(
SELECT DV.NOMEMPRESA
FROM descarregas dc INNER JOIN desenvolupaments dm ON dc.idaplicacio = dm.idaplicacio
INNER JOIN desenvolupadors dv ON dv.iddesenvolupador = dm.iddesenvolupador
WHERE dc.ao = aoultimo
ORDER BY dc.iddescarrega desc)
WHERE ROWNUM=1;

SELECT * INTO nomapp FROM
(SELECT ap.nomaplicacio
FROM descarregas dc INNER JOIN aplicacions ap ON ap.idaplicacio =dc.idaplicacio
WHERE dc.ao = aoultimo
AND dc.iddescarrega = ult_iddescarrega
)
WHERE ROWNUM =1;


SELECT * INTO precioapp FROM
(SELECT dc.preuaplicacio
FROM descarregas dc 
WHERE  dc.iddescarrega = ult_iddescarrega
)
WHERE ROWNUM =1;


UPDATE tfc.factacumulades
  SET factacumulades.totalfactapp = totalfactapp + precioapp
  WHERE
   factacumulades.app =nomapp AND factacumulades.factany =aoultimo;
 
SELECT * 
INTO totalnuevo 
FROM 
(SELECT  (factacumulades.totalfactapp)
FROM tfc.factacumulades
WHERE
  factacumulades.app = nomapp
 AND factacumulades.factany =aoultimo)
WHERE ROWNUM  = 1;

BEGIN

IF (totalnuevo < precioapp)
THEN totalnuevo := precioapp;
END IF;


UPDATE TFC.maxfactacum
SET maxfactacum.maxfactapp = totalnuevo,
    maxfactacum.maxapp = nomapp,
    maxfactdesenv = nomempresa
  WHERE maxfactacum.maxfactany =aoultimo
 AND maxfactacum.maxfactapp < totalnuevo;
 
END;
SELECT 'S'
         INTO existeAPA
         FROM tfc.factacumulades
        WHERE factany  = aoultimo
          AND app = nomapp
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
        UPDATE TFC.maxfactacum
SET maxfactacum.maxfactapp = precioapp,
    maxfactacum.maxapp = nomapp,
    maxfactdesenv = nomempresa
  WHERE
  maxfactacum.maxfactapp < precioapp
 AND maxfactacum.maxfactany =aoultimo;
        
        INSERT INTO tfc.factacumulades (totalfactapp,app,factdesenv,factany)
  VALUES(precioapp,nomapp,nomempresa,aoultimo);

  
  
  
  END;


UPDATE TFC.maxfactacum
SET maxfactacum.maxfactapp = totalnuevo,
    maxfactacum.maxapp = nomapp,
    maxfactdesenv = nomempresa
  WHERE
  maxfactacum.maxfactapp < totalnuevo
 AND maxfactacum.maxfactany =aoultimo;
BEGIN
SELECT 'S'
         INTO existeMPA
         FROM tfc.maxfactacum
        WHERE maxfactany  = aoultimo
        AND ROWNUM  = 1; 
 EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
   
        INSERT INTO TFC.maxfactacum (maxfactapp,maxapp,maxfactdesenv,maxfactany)
        VALUES(precioapp,nomapp,nomempresa,aoultimo);
    END;
    
    SELECT * 
INTO totalnuevo 
FROM 
(SELECT  (factacumulades.totalfactapp)
FROM tfc.factacumulades
WHERE
  factacumulades.app = nomapp
 AND factacumulades.factany =aoultimo)
WHERE ROWNUM  = 1;        
        
        

END;


END TR_AFT_INS_DESC_EST5_TC1;
/
spool off;