SET SERVEROUTPUT ON;
spool P20-logSELECTSR5.log
set echo on
CONNECT TFC/hola;
set heading on
--
-- Consulta 1: listado con todos los desarrolladores de un pas
-- ------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

COL NOMBRE FORMAT A12
COL NUM FORMAT 999
COL NOMREPLEGAL FORMAT A10
COL APELLIDO FORMAT A10
COL DIRECCIN FORMAT A10
COL TLF FORMAT 99999999999


SELECT NOMEMPRESA AS NOMBRE, NUMAPLICACIONS AS NUM,
NOMREPLEGAL AS NOMBRE, COGNOM1REPLEGAL AS APELLIDO,COGNOM12REPLEGAL AS APELLIDO,
ADREAOFICINA AS DIRECCIN,
TELEFON AS TLF FROM TABLE(FU_LIST_DESARROLLADORES_PAIS('ES'));

--
---- Consulta 2: Funcin que devuelve un listado con todos las aplicaiones descargadas
--                con sus datos principales ordenadas por nmero de descarga. En caso
--                de que la aplicacion tenga varias versiones o este disponible en varios 
--                pases se mostraran los datos por versin y pais pero con el total 
--                absoluto de descargas.

-- ------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

COL NOMBRE FORMAT A12
COL SO FORMAT A12
COL PREUAPLICACIO FORMAT 999.99
COL DESCRIPCIO FORMAT A15

 SELECT NUMDESCARREGAS AS NMERO, NOMAPLICACIO AS NOMBRE,
 NOMSO AS SO, CODPAIS AS PAIS, PREUAPLICACIO AS PRECIO, DESCRIPCIO AS DESCRIPCION FROM TABLE(FU_LIST_APLICACIONES_DESC);
 
-- Consulta 3: Funcin que devuelve un listado con el nmero de descargas por pais
--   para una aplicacin y ao dados
-- ------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

COL CODPAIS FORMAT A6 
COL NUMDESCARGAS FORMAT 99999999

SELECT PAISUSUARI AS PAIS,NUMDESCARGAS AS NMERO FROM TABLE(FU_LIST_APLIC_ANO_PAIS('GRADIUS','2011'));

-- Consulta 4: Funcin que devuelve un listado la actividad de descargas por usuario
--                en la plataforma por fecha y aplicacin de descarga


-- ------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

COL NOMBRE FORMAT A12 
COL PRECIO FORMAT 9999.99
COL PAGO FORMAT A12

       SELECT DATADESCARREGA AS FECHA,
       NOMAPLICACIO AS NOMBRE,
       PREUAPLICACIO AS PRECIO,
       MODEPAGAMENT AS PAGO
       FROM TABLE(FU_LIST_ACTIVIDAD_USR('616634676'));
       
       
--Consulta 5: Funcin que devuelve un listado de los 20 usuarios que ms han
--gastado en aplicaciones para una ao dado



-- ------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

COL NUMERO FORMAT 9999999999
COL NOMBRE FORMAT A12 
COL PRECIO FORMAT 9999.99
COL PAGO FORMAT A12

SELECT NUMMOBIL AS NUMERO,
NOMUSUARI AS NOMBRE,
COGNOM1USUARI AS APELLIDO,
COGNOM2USUARI AS APELLIDO, 
FACTURACION
FROM TABLE(FU_TOP20_USR('2011'));

SPOOL OFF;