SET SERVEROUTPUT ON;
spool P21-logESTADISTICAS.log
set echo on
CONNECT TFC/hola;
set heading on

---CONSULTA 1. Nmero total de descargas de la plataforma hasta ahora mismo
------------------------------------------------------------------------
SELECT NUMDESCARREGAS AS NDESCARGAS FROM TOTALES;

---CONSULTA 2. Nmero total de  generados en descargas en la plataforma 
------------------------------------------------------------------------
SELECT FACTDESCARREGAS AS FACTURACIN FROM TOTALES;

---CONSULTA 3. Para un ao concreto n medio de descargas realizadas por usuario
--------------------------------------------------------------------------------
SELECT MEDIADESC AS MEDIA FROM MEDIADESCPERUSUARI
WHERE ANYMEDIADESC = 2011;

---CONSULTA 4. Para un ao concreto desarrollador con mayor num de descargas
-- y nmero de las mismas
--------------------------------------------------------------------------------
SELECT MAXDESCACUM AS NDESCARGAS, MAXDESENVDESCACUM AS NOMBRE FROM MAXACUMULADES
WHERE MAXANYDESCACUM = 2010;

---CONSULTA 5. Para un ao concreto aplicacin que ms dinero ha recaudado 
--- y su desarrollador
--------------------------------------------------------------------------------
SELECT MAXFACTDESENV AS DESARROLLADOR, MAXAPP AS APLICACIN FROM MAXFACTACUM
WHERE MAXFACTANY = 2004;

---CONSULTA 6. Para un ao y un pas concretos nmero de usuarios que han tenido
-- al menos una descarga
--------------------------------------------------------------------------------
SELECT ESTNUMUSDIF AS USUARIOS FROM ESTANYPAIS
WHERE ESTPAIS= 'ES' AND ESTANY = 2011;

---CONSULTA 7. Para un ao y un pas concretos los ingresos totales que han
-- generado en descargas los usuarios de ese pas.
--------------------------------------------------------------------------------

SELECT ESTFACTPAIS AS FACTURACIN FROM ESTANYPAIS
WHERE ESTPAIS= 'ES' AND ESTANY = 2011;

---CONSULTA 8. Para un ao y un pas concretos nmero de aplicaciones descargadas
-- al menos una vez.
--------------------------------------------------------------------------------
SELECT ESTNUMAPPDIF  AS NUMERO FROM ESTANYPAIS
WHERE ESTPAIS= 'ES' AND ESTANY = 2011;


SPOOL OFF;