spool BD\31-logTR_AFT_INS_DESC_EST4_TC1.log
connect tfc/hola;

CREATE OR REPLACE TRIGGER TFC.TR_AFT_INS_DESC_EST4_TC1
AFTER INSERT ON TFC.DESCARREGAS  
DECLARE
numdesenv NUMBER;
nomempresa VARCHAR2(50);
numdesc NUMBER;
numdescusuari NUMBER;
mediaper NUMBER;

aoultimo NUMBER;
ult_iddescarrega NUMBER;
usuariodif NUMBER;
EXISTE  VARCHAR2(3);
existeAFA VARCHAR2(1);
existeMFA VARCHAR2(1);
totalnuevo NUMBER;

/*******************************************************************************
*Este trigger acumula para despues de cada descarga por ao 
*la aplicacin que ms ha recaudado as como su desarrollador
* a partir de una tabla de acumulados de descargas para cada desarrollador
********************************************************************************/

BEGIN

existeMFA :='N';

SELECT * 
INTO ult_iddescarrega 
FROM 
(SELECT  (DESCARREGAS.IDDESCARREGA)
FROM tfc.DESCARREGAS
ORDER BY iddescarrega DESC)
WHERE ROWNUM  = 1;

SELECT  (DESCARREGAS.AO)
INTO aoultimo 
FROM DESCARREGAS
where iddescarrega =ult_iddescarrega;

SELECT * INTO nomempresa FROM(
SELECT DV.NOMEMPRESA
FROM descarregas dc INNER JOIN desenvolupaments dm ON dc.idaplicacio = dm.idaplicacio
INNER JOIN desenvolupadors dv ON dv.iddesenvolupador = dm.iddesenvolupador
WHERE dc.ao = aoultimo
ORDER BY dc.iddescarrega desc)
WHERE ROWNUM=1;


UPDATE tfc.descacumulades
  SET descacumulades.totaldescacumulades = totaldescacumulades + 1
  WHERE
  descacumulades.desenvdescacumulades = nomempresa
 AND descacumulades.anydescacumulades =aoultimo;
 
 
 
SELECT * 
INTO totalnuevo 
FROM 
(SELECT  (descacumulades.totaldescacumulades)
FROM tfc.descacumulades
WHERE
  descacumulades.desenvdescacumulades = nomempresa
 AND descacumulades.anydescacumulades =aoultimo)
WHERE ROWNUM  = 1;

UPDATE TFC.maxacumulades
SET maxacumulades.maxdescacum = totalnuevo,
    maxacumulades.maxdesenvdescacum = nomempresa
  WHERE
  maxacumulades.maxdescacum < totalnuevo
 AND maxacumulades.maxanydescacum =aoultimo;


SELECT 'S'
         INTO existeAFA
         FROM tfc.descacumulades
        WHERE anydescacumulades  = aoultimo
          AND desenvdescacumulades =nomempresa
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
        INSERT INTO tfc.descacumulades (totaldescacumulades,desenvdescacumulades,anydescacumulades)
  VALUES(1,nomempresa,aoultimo);
  
  END;

BEGIN
SELECT 'S'
         INTO existeMFA
         FROM tfc.maxacumulades
        WHERE maxanydescacum  = aoultimo
        AND ROWNUM  = 1; 
 EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
   
        INSERT INTO TFC.maxacumulades (maxdescacum,maxdesenvdescacum,maxanydescacum)
        VALUES(1,nomempresa,aoultimo);
    END;
END;


END TR_AFT_INS_DESC_EST4_TC1;
/
spool off;