

spool  BD\33-logTR_AFT_INS_DESC_EST6_TC1.log

CONNECT TFC/hola;

create or replace TRIGGER TFC.TR_AFT_INS_DESC_EST6_TC1
AFTER INSERT ON TFC.DESCARREGAS
DECLARE
est_pais VARCHAR2(2);
paisultimo VARCHAR2(2);
usrultimo NUMBER;
est_ao NUMBER;
est_numusdif  NUMBER;
est_factpais NUMBER;
est_numappdif NUMBER;
aomedia NUMBER;
aoultimo NUMBER;
idap    NUMBER; 
ult_iddescarrega NUMBER;
EXISTE  VARCHAR2(3);
existeAcumApp VARCHAR2(3);
existeao VARCHAR2(3);
precioapp NUMBER;
existeAcum VARCHAR2(1);
acumdesc NUMBER;
maxacumdesc NUMBER;
appultima NUMBER;
acumdescapp NUMBER;
/*******************************************************************************
*Este trigger calcula para despues de cada descarga por ao y pas
*el numero de usuarios diferentes que ha hecho como mnimo una descarga,
*los ingresos totales generados por los usuarios de un pais en una ao
*y el nmero de aplicaciones diferentes descargadas por
*ao y pas mediante el uso de tablas auxiliares
*
********************************************************************************/
BEGIN
SELECT * 
INTO ult_iddescarrega 
FROM 
(SELECT  (DESCARREGAS.IDDESCARREGA)
FROM tfc.DESCARREGAS
ORDER BY iddescarrega DESC)
WHERE ROWNUM  = 1;


SELECT * INTO precioapp FROM
(SELECT dc.preuaplicacio
FROM descarregas dc 
WHERE  dc.iddescarrega = ult_iddescarrega
)
WHERE ROWNUM =1;

SELECT * INTO appultima FROM
(SELECT dc.preuaplicacio
FROM descarregas dc 
WHERE  dc.iddescarrega = ult_iddescarrega
)
WHERE ROWNUM =1;

SELECT  (DESCARREGAS.AO)
INTO aoultimo 
FROM DESCARREGAS
where iddescarrega =ult_iddescarrega;

SELECT usr.paisusuari
INTO paisultimo
FROM(( descarregas dc INNER JOIN imei im ON im.codimei = dc.codimei)
INNER JOIN usuaris usr ON im.idusuariimei =usr.idusuari)
where dc.iddescarrega=ult_iddescarrega;

SELECT usr.idusuari
INTO usrultimo
FROM(( descarregas dc INNER JOIN imei im ON im.codimei = dc.codimei)
INNER JOIN usuaris usr ON im.idusuariimei =usr.idusuari)
where dc.iddescarrega=ult_iddescarrega;


SELECT MAX (estanypais.estany) 
INTO aomedia
FROM estanypais;


SELECT * INTO est_pais FROM 
(SELECT estpais
FROM estanypais
ORDER BY (estany) DESC)
WHERE ROWNUM =1;

UPDATE TFC.estanypais
SET estanypais.estfactpais = precioapp + estanypais.estfactpais
  WHERE estanypais.estany = aoultimo
 AND estanypais.estpais = paisultimo;

BEGIN

SELECT 'S'
         INTO existe
         FROM tfc.estanypais
        WHERE estany  = aoultimo
          AND estpais = paisultimo
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        
        
        INSERT INTO tfc.estanypais (estpais,estany,estnumusdif,estfactpais)
  VALUES(paisultimo,aoultimo,1,precioapp);
END;
BEGIN


  


  SELECT * INTO acumdesc FROM 
(SELECT acumusdif
FROM numusdifdesc
WHERE anyidusuari  = aoultimo
AND paisidusuari = paisultimo 
ORDER BY (acumusdif) DESC)
WHERE ROWNUM =1;
EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
    NULL;
END;
--
IF (acumdesc = NULL)
THEN
acumdesc := 0;
END IF;

 
  BEGIN
  SELECT 'S'
         INTO existeAcum
         FROM tfc.numusdifdesc
        WHERE anyidusuari  = aoultimo
         AND paisidusuari = paisultimo
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
      INSERT INTO TFC.numusdifdesc(idusuaridesc,paisidusuari,anyidusuari,acumusdif)
  VALUES (usrultimo,paisultimo,aoultimo,1);
  UPDATE TFC.estanypais
SET estanypais.estnumusdif = 1
  WHERE estanypais.estany = aoultimo
 AND estanypais.estpais = paisultimo;
        END;
        END;
  --
  BEGIN
  
  IF (existeAcum = 'S')
  THEN
  BEGIN
  SELECT 'S'
         INTO existeAcum
         FROM tfc.numusdifdesc
        WHERE anyidusuari  = aoultimo
         AND paisidusuari = paisultimo
         AND idusuaridesc = usrultimo
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
     INSERT INTO TFC.numusdifdesc(idusuaridesc,paisidusuari,anyidusuari,acumusdif)
  VALUES (usrultimo,paisultimo,aoultimo,acumdesc +1);
  UPDATE TFC.estanypais
SET estanypais.estnumusdif = acumdesc + 1
  WHERE estanypais.estany = aoultimo
 AND estanypais.estpais = paisultimo;
      END;
  END;
  END IF;
  END;
  
  
BEGIN

SELECT * INTO maxacumdesc FROM
(SELECT numusdifdesc.acumusdif
FROM numusdifdesc
WHERE  numusdifdesc.paisidusuari = paisultimo
AND numusdifdesc.anyidusuari = aoultimo
ORDER BY acumusdif DESC)
WHERE ROWNUM =1;

UPDATE TFC.estanypais
SET estanypais.estnumusdif = maxacumdesc
WHERE estanypais.estany = aoultimo
AND estanypais.estpais = paisultimo;
END;


BEGIN

 SELECT * INTO acumdescapp FROM 
(SELECT acumaplicdif
FROM numappdifdesc
WHERE anyidaplic  = aoultimo
AND paisidaplic = paisultimo 
ORDER BY (acumaplicdif) DESC)
WHERE ROWNUM =1;
EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
    NULL;
END;
--
IF (acumdescapp = NULL)
THEN
acumdescapp := 0;
END IF;

 
  BEGIN
  SELECT 'S'
         INTO existeAcumApp
         FROM tfc.numappdifdesc
        WHERE anyidaplic  = aoultimo
         AND paisidaplic = paisultimo
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
      INSERT INTO TFC.numappdifdesc(idaplicdesc,paisidaplic,anyidaplic,acumaplicdif)
  VALUES (appultima,paisultimo,aoultimo,1);
  UPDATE TFC.estanypais
SET estanypais.estnumappdif = 1
  WHERE estanypais.estany = aoultimo
 AND estanypais.estpais = paisultimo;
        END;
        END;
  
  
  BEGIN
  
  IF (existeAcumApp = 'S')
  THEN
  BEGIN
  SELECT 'S'
         INTO existeAcumApp
         FROM tfc.numappdifdesc
        WHERE anyidaplic  = aoultimo
         AND paisidaplic = paisultimo
         AND idaplicdesc = appultima
          AND ROWNUM  = 1;
    EXCEPTION
        WHEN NO_DATA_FOUND 
        THEN
        BEGIN
     INSERT INTO TFC.numappdifdesc(idaplicdesc,paisidaplic,anyidaplic,acumaplicdif)
  VALUES (appultima,paisultimo,aoultimo,acumdescapp +1);
  UPDATE TFC.estanypais
SET estanypais.estnumappdif = acumdescapp + 1
  WHERE estanypais.estany = aoultimo
 AND estanypais.estpais = paisultimo;
      END;
  END;
  END IF;
  

  
  
        
        
END;
     
END TR_AFT_INS_DESC_EST6_TC1;
/
spool off;