spool BD\6-log_triggers.log

/*
  
   TRIGGERS PARA INSERCIONES CON LAS SECUENCIAS GENERADAS

 */
--DROP TRIGGER TFC.TR_BEF_INS_DESENVOLUPADORS;

CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_DESENVOLUPADORS
BEFORE INSERT ON DESENVOLUPADORS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDDESENVOLUPADOR.NEXTVAL 
   INTO :NEW.IDDESENVOLUPADOR        
   FROM DUAL; 
END TR_BEF_INS_DESENVOLUPADORS;  
/
CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_IDAPLICACIO
BEFORE INSERT ON APLICACIONS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDAPLICACIO.NEXTVAL 
   INTO :NEW.IDAPLICACIO        
   FROM DUAL; 
END TR_BEF_INS_IDAPLICACIO;              
/
CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_USUARIS
BEFORE INSERT ON USUARIS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDUSUARI.NEXTVAL 
   INTO :NEW.IDUSUARI        
   FROM DUAL; 
END TR_BEF_INS_USUARIS;              

/

CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_SO
BEFORE INSERT ON SISTEMASOPERATIUS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDSO.NEXTVAL 
   INTO :NEW.IDSO        
   FROM DUAL; 
END TR_BEF_INS_S0;              

/

CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_IMEI
BEFORE INSERT ON IMEI FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDIMEI.NEXTVAL 
   INTO :NEW.IDIMEI        
   FROM DUAL; 
END TR_BEF_INS_IMEI;              

/

create or replace TRIGGER TFC.TR_BEF_INS_DESENVOLUPAMENTS
BEFORE INSERT ON DESENVOLUPAMENTS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDDESENVOLUPAMENTS.NEXTVAL 
   INTO :NEW.IDDESENVOLUPAMENT       
   FROM DUAL; 
END TR_BEF_INS_DESENVOLUPAMENTS;  

/
CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_IDDESCARREGA
BEFORE INSERT ON DESCARREGAS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDDESCARREGA.NEXTVAL 
   INTO :NEW.IDDESCARREGA        
   FROM DUAL; 
END TR_BEF_INS_IDDESCARREGA;  
/
CREATE OR REPLACE TRIGGER TFC.TR_BEF_INS_IDLOG
BEFORE INSERT ON LOGS FOR EACH ROW 
BEGIN
 SELECT TFC.SQ_IDLOG.NEXTVAL 
   INTO :NEW.IDLOG        
   FROM DUAL; 
END TR_BEF_INS_IDLOG;  
/
spool off