spool BD\8-log_CreacionTablasEst.log


DROP TABLE TFC.totales;


CREATE TABLE TFC.totales
(
  numdescarregas  NUMBER ,
  factdescarregas NUMBER 
  )
  TABLESPACE TS_TAULES;
  
  
  INSERT INTO TFC.totales (numdescarregas,factdescarregas)
  VALUES (0,0);

DROP TABLE TFC.mediadescperusuari;

CREATE TABLE TFC.mediadescperusuari
(
  anymediadesc  NUMBER  ,
  mediadesc NUMBER  ,
  numdescargas NUMBER,
  numusdif NUMBER
  )
  TABLESPACE TS_TAULES;
  
INSERT INTO TFC.mediadescperusuari (anymediadesc,numdescargas,mediadesc,numusdif)
  VALUES (0,0,0,0);
  
DROP TABLE TFC.numusuariany;

CREATE TABLE TFC.numusuariany
(
  anyusuari  NUMBER  ,
  idusuariany NUMBER  ,
  numusdifany NUMBER,
  sumdesc NUMBER
  )
  TABLESPACE TS_TAULES;
  
INSERT INTO TFC.numusuariany (anyusuari,idusuariany,numusdifany,sumdesc)
  VALUES (0,0,0,0);
  
 
 DROP TABLE TFC.estanypais;
 
CREATE TABLE TFC.estanypais
(
  estpais  VARCHAR2(2),
  estany NUMBER,
  estnumusdif NUMBER,
  estfactpais NUMBER,
  estnumappdif NUMBER
  )
  TABLESPACE TS_TAULES;
  
  INSERT INTO TFC.estanypais (estpais,estany,estnumusdif,estfactpais,estnumappdif)
  VALUES ('XX',0,0,0,0);


DROP TABLE TFC.descacumulades;

/*
Tabla de acumulados para el trigger de la cuarta consulta de estadisticas
*/

CREATE TABLE TFC.descacumulades
(
  totaldescacumulades  NUMBER,
  desenvdescacumulades VARCHAR2(20),
  anydescacumulades NUMBER
  )
  TABLESPACE TS_TAULES;
   
 
  INSERT INTO TFC.descacumulades (totaldescacumulades,anydescacumulades)
  VALUES (0,0);
  
  

/*
Tabla de mximos acumulados para el trigger de la cuarta consulta de estadisticas
*/

DROP TABLE TFC.maxacumulades;


CREATE TABLE TFC.maxacumulades
(
  maxdescacum  NUMBER ,
  maxdesenvdescacum VARCHAR2(20),
  maxanydescacum NUMBER
  )
  TABLESPACE TS_TAULES;
  
  
  INSERT INTO TFC.maxacumulades (maxdescacum,maxanydescacum)
  VALUES (0,0);


/*
Tabla de facturacin acumulada para el trigger de la quinta consulta de estadisticas
*/


DROP TABLE TFC.factacumulades;


CREATE TABLE TFC.factacumulades
(
  totalfactapp  NUMBER ,
  app VARCHAR2(40),
  factdesenv VARCHAR2(20),
  factany NUMBER
  )
  TABLESPACE TS_TAULES;
  
  
  INSERT INTO TFC.factacumulades (totalfactapp,factany)
  VALUES (0,0);

/*
Tabla de mxima facturacin acumulada para el trigger de la quinta consulta de estadisticas
*/

  DROP TABLE TFC.maxfactacum;


CREATE TABLE TFC.maxfactacum
(
  maxfactapp  NUMBER ,
  maxapp VARCHAR2(40),
  maxfactdesenv VARCHAR2(20),
  maxfactany NUMBER
  )
  TABLESPACE TS_TAULES;
  
  
  INSERT INTO TFC.maxfactacum (maxfactapp,maxfactany)
  VALUES (0,0);


DROP TABLE TFC.numusdifdesc;
 
CREATE TABLE TFC.numusdifdesc
(
  idusuaridesc  NUMBER,
  paisidusuari VARCHAR2(2),
  anyidusuari NUMBER,
  acumusdif NUMBER)
  TABLESPACE TS_TAULES;
  
  INSERT INTO TFC.numusdifdesc(idusuaridesc,paisidusuari,anyidusuari,acumusdif)
  VALUES (0,'XX',0,0);

DROP TABLE TFC.numappdifdesc;
 
CREATE TABLE TFC.numappdifdesc
(
  idaplicdesc  NUMBER,
  paisidaplic VARCHAR2(2),
  anyidaplic NUMBER,
  acumaplicdif NUMBER)
  TABLESPACE TS_TAULES;
  
  INSERT INTO TFC.numappdifdesc(idaplicdesc,paisidaplic,anyidaplic,acumaplicdif)
  VALUES (0,'XX',0,0);
  
  
/
spool off;